
var deviceConnected = false;
var conDialog;
var devName = 'UC Device';
var currentSubTitle = '';

function replaceEventListener(elname, func)
{
	var el = document.getElementById(elname);

	elClone = el.cloneNode(true);
	el.parentNode.replaceChild(elClone, el);

	elClone.addEventListener('click', func);
}

function setTitles(title, subtitle, title1) {
	var span, txt;
	
  if (title !== '') {
  	span = document.getElementById('titleArea');
  	txt = document.createTextNode(title);
  	span.innerText = txt.textContent;
  }

	span = document.getElementById('subtitleArea');
	txt = document.createTextNode(subtitle);
	currentSubTitle = subtitle;
	span.innerText = txt.textContent;

	span = document.getElementById('titleArea1');
  if (title1 === undefined)
  	txt = document.createTextNode('');
  else
  	txt = document.createTextNode(title1);
  
  if (title1 !== undefined)
  	span.innerText = txt.textContent;
}

function setButtons(but1, but2, but3, but4) {
	var span, txt;
	
	span = document.getElementById('But1');
	txt = document.createTextNode(but1);
	span.innerHTML = txt.textContent;
	
	span = document.getElementById('But2');
	txt = document.createTextNode(but2);
	span.innerText = txt.textContent;
  disableButton('But2', currentOperation);

	span = document.getElementById('But3');
	txt = document.createTextNode(but3);
	span.innerText = txt.textContent;

	span = document.getElementById('But4');
	txt = document.createTextNode(but4);
	span.innerText = txt.textContent;
}

function showDeviceState(connected) {
  
  deviceConnected = connected.state != 'Disconnected';
  
		span = document.getElementById('textval1');

		txt = document.createTextNode(connected.state);
		span.innerText = txt.textContent;
		
		disableButton('But3', !deviceConnected);

		span = document.getElementById('titleArea1');
		var testString = currentSubTitle.substring(0, 6);
		if (testString == 'Device') {
		  disableButton('But2', !deviceConnected);
  		disableButton('But4', !deviceConnected);
		} else {
		  disableButton('But2', false);
  		disableButton('But4', false);
		}
		
		switch(connected.type) {
  		case USB_PRODUCT_ID3:
        txt = document.createTextNode("UC1000");
        devName = 'UC1000';
		    break;
		  case USB_PRODUCT_ID4:
        txt = document.createTextNode("UC1500");
        devName = 'UC1500';
        break;
      case USBDEV_REVO1:
      case USBDEV_REVO2:
        txt = document.createTextNode("UC500");
        devName = 'UC500';
        break;
      default:
        txt = document.createTextNode("UC Device");
        devName = 'UC Device';
        break;
		}
    
 		span.innerText = txt.textContent;

}

function updateConnStatus() {
	checkDevice(showDeviceState);
}

function onPlugDevice(device) {
	console.log('Plug device ' + device.vendorId + ':' + device.productId);
	updateConnStatus();
}

function onPullDevice(device) {
	console.log('Pulled device ' + device.vendorId + ':' + device.productId);
  CloseBulkConnection();
	updateConnStatus();
}

function doClose() {
	var verwin = chrome.app.window.get('ucVersion');
	if (verwin)
		verwin.close();
	var logwin = chrome.app.window.get('ucGetLogs');
	if (logwin)
		logwin.close();
	var upgwin = chrome.app.window.get('ucUpgrade');
	if (upgwin) {
		// check for in-progress?
		upgwin.close();
	}
	close();
}

function doInfo() {
	//console.log("do Info");
	window.open('http://www.revolabs.com/products/product-line/flx-uc-500');
}

function imHidConnect(id, opcode) {
  console.log('connected to HID: ' + id);
}

function doAbout() {
	abtDialog.showModal();
}

function doGetLogs() {
	//console.log("do GetLogs");
  if (isHidConnected()) {
    hidGetIp();
    return;
  }

	if (deviceConnected) {
		var logwin = chrome.app.window.get('ucGetLogs');
		if (logwin) {
			logwin.show();
		} else {
			chrome.app.window.create('uc500logs.html', {
				'id': 'ucGetLogs',
				innerBounds: {
          'width': 700,
          'height': 351,
          'minWidth': 700,
          'minHeight': 351,
          'maxWidth': 700,
          'maxHeight': 351
				}
			});
		}
	} else {
		conDialog.showModal();
	}
}

function doVersions() {
	//console.log("do Versions");
	if (deviceConnected) {
		var verwin = chrome.app.window.get('ucVersion');
		if (verwin) {
			verwin.show();
		} else {
			chrome.app.window.create('uc500vers.html', {
				'id': 'ucVersion',
				innerBounds: {
          'width': 440,
          'height': 300,
          'minWidth': 440,
          'minHeight': 300,
          'maxWidth': 440,
          'maxHeight': 300
				}
			});
		}
	} else {
		conDialog.showModal();
	}
}

function hidGetIp() {
  var bytes = new Uint8Array(1);
  console.log('connected via HID, waiting for data...');
  bytes[0] = HID_CMD_GET_IP;
  
  chrome.hid.send(hidConnection.connId, HID_REPORT_ID, bytes.buffer, function() {
      if (chrome.runtime.lastError !== undefined) {
       console.warn('chrome.hid.send error: ' +
               chrome.runtime.lastError.message);
        return;
      }

      chrome.hid.receive(hidConnection.connId, function(reportId, data) {
        var inData = new Uint8Array(data);
        
        // make sure it's our IP request info
        if (inData[0] != 4) { 
          hidGetIp();
          return;
        }
        
        var ipAddr = intToChar(inData);
        ipAddr = ipAddr.slice(1, 16).trim();
        console.log('device IP: ' + ipAddr);
        if (ipAddr.slice(0, 7).trim() != '0.0.0.0') {
          //ipAddr = "216.58.219.206";
          var URL = "http://" + ipAddr;
          window.open(URL);
        }
      });
  });
}

function doUpgrade() {
	//console.log("do Upgrade");
  if (isHidConnected()) {
      hidGetIp();
      return;
	}
	
	if (deviceConnected) {
		var upgwin = chrome.app.window.get('ucUpgrade');
		if (upgwin) {
			upgwin.show();
		} else {
			chrome.app.window.create('uc500upg.html', {
				'id': 'ucUpgrade',
				innerBounds: {
          'width': 700,
          'height': 351,
          'minWidth': 700,
          'minHeight': 351,
          'maxWidth': 700,
          'maxHeight': 351
				} 
			});
		}
	} else {
		conDialog.showModal();
	}
}

function doSupport() {
	//console.log("do Support");
	window.open('mailto: support@revolabs.com?subject=FLX UC500 Support Request&body=Support Details');
}

function doAdmin() {
	//console.log("do Admin");
	if (deviceConnected) {
		setTitles('', 'Device Administration - Select action from menu');
		setButtons('Home', 'Get Logs', 'Get Versions', 'Upgrade');
		replaceEventListener('But1', doHome);
		replaceEventListener('But2', doGetLogs);
		replaceEventListener('But3', doVersions);
		replaceEventListener('But4', doUpgrade);
	} else {
		conDialog.showModal();
	}
}

function doHelp() {
	//console.log("do Help");
	setTitles('', 'Help - Select topic from menu');
	setButtons('Home', 'About', 'Product Info', 'Support');
	replaceEventListener('But1', doHome);
	replaceEventListener('But2', doAbout);
	replaceEventListener('But3', doInfo);
	replaceEventListener('But4', doSupport);
	disableButton('But3', false);
}

function doHome() {
	//console.log("do Home");
	//setTitles('FLX\u2122 UC500', 'USB CONFERENCE PHONE FOR UNIFIED COMMUNICATION');
	setTitles('FLX\u2122', 'USB CONFERENCE PHONE FOR UNIFIED COMMUNICATION', devName);
	setButtons('Close', 'About', 'Administration', 'Help');
	replaceEventListener('But1', doClose);
	replaceEventListener('But2', doAbout);
	replaceEventListener('But3', doAdmin);
	replaceEventListener('But4', doHelp);

	chrome.usb.onDeviceAdded.addListener(onPlugDevice);
	chrome.usb.onDeviceRemoved.addListener(onPullDevice);

	updateConnStatus();

	// every second, check that the device is connected
	/* not needed, using events
	setInterval(updateConnStatus, 1000);
	*/
}

document.addEventListener('DOMContentLoaded', function () {
	conDialog = document.getElementById('connectMeDialog');
	document.querySelector('#connectMeClose').onclick = function() {
		conDialog.close();
	};
	abtDialog = document.getElementById('aboutDialog');
	document.querySelector('#aboutClose').onclick = function() {
		abtDialog.close();
	};
	appver = document.getElementById('appVersion');
	appver.textContent = chrome.runtime.getManifest().version;
	doHome();
});

