var defaultLogFile = 'FLX_UC_Device_Manager_Log';
var isconnected = false;
var fetchAborted = false;
var conDialog;
var logContent, logBuf, logIndex;
var totalProgress = 0;

function reportStatus(statstr) {
	var ta = document.getElementById('status');
	ta.value += (statstr + '\n');
    ta.scrollTop = ta.scrollHeight;
}

function setProgress(percent) {
	totalProgress = percent;
	if (totalProgress < 0)
		totalProgress = 0;
	else if (totalProgress > 100)
		totalProgress = 100;
	pb = document.getElementById('progbar');
	pb.style.width = 0.98 * totalProgress + '%';
	
 	pb = document.getElementById('progArea');
	
  str = parseInt(totalProgress) + '%';
  if (str != '0%')
  	pb.textContent = str;
}

function onSelPath() {
	var accepts = [{
		mimeTypes: ['text/*'],
		extensions: ['zip']
	}];

  var now = new Date();
  var day = now.getDate();
  var month = now.getMonth()+1;
  var year = now.getFullYear();
  var hour = now.getHours();
  var minute = now.getMinutes();
  var second = now.getSeconds();
  
  day = day < 10 ? '0'+day:day;
  month = month < 10 ? '0'+month:month;
  hour = hour < 10 ? '0'+hour:hour;
  minute = minute < 10 ? '0'+minute:minute;
  second = second < 10 ? '0'+second:second;
  
  var postFix = '_' + year + month + day + '_' + hour + minute + second;
  
	suggestedLogFile = defaultLogFile + postFix + '.zip';

	chrome.fileSystem.chooseEntry({type: 'saveFile', suggestedName: suggestedLogFile },
			function(theEntry) {
		
		var selectedFilename;
		var blob;

		if (! theEntry) {
			return;
		}
		
		// use local storage to retain access to this file
		chrome.storage.local.set({'chosenFile': chrome.fileSystem.retainEntry(theEntry)});

		chrome.fileSystem.getDisplayPath(theEntry, function(displayPath) {
		  span = document.getElementById('logpath');
			span.value = displayPath;
			
			button = document.getElementById('retrieve'); 
  		button.disabled = false;
		});
  });
}

function writeLogData() {
	chrome.storage.local.get('chosenFile', function(items) {
	if (items.chosenFile) {

    var chosenFileName;
    var blob;

		// if an entry was retained earlier, see if it can be restored
		chrome.fileSystem.isRestorable(items.chosenFile, function(bIsRestorable) {
			// the entry is still there, load the content
			chrome.fileSystem.restoreEntry(items.chosenFile, function(chosenEntry) {
				if (chosenEntry) {
		      chrome.fileSystem.getDisplayPath(chosenEntry, function(displayPath) {
          chosenFileName = displayPath;  
          
     			chosenEntry.createWriter(function(fileWriter) {
    				fileWriter.onwriteend = function(e) {
    						console.log('Write completed.');
      				  reportStatus('Operation Complete!');
    						//reportStatus('Wrote file ' + chosenFileName);
    						fileWriter.flush();
    						fileWriter.close();
    					};
    				fileWriter.onerror = function(e) {
    						console.log('Write failed: ' + e.toString());
    						fileWriter.close();
    					};
    
    				reportStatus('Writing file...');
    				// Create a new Blob and write it to log file.
    				blob = new Blob([logBuf], { type: "application/zip" });
    				fileWriter.write(blob);
  			});         
          
		      });
				}
			});
 	 		});
	} else {
		reportStatus('Missing firmware file');
	}

  });
}

function abortFetch() {
	fetchAborted = true;
	reportStatus('Aborted fetch');
	disableButton('abort', true);
	disableButton('retrieve', false);
}

function clearLogContent() {
	var ta = document.getElementById('status');
	ta.value = '';
}

function reportSerialStatus(status) {
	// don't put serial-port status updates into our log view
	console.log('sp:' + status);
}

var logPacketCount = 0;
var logPacketRead  = 0;
var logFileLen     = 0;

function setGroupButton(p, a, r) {
    disableButton('selpath', p);		
		disableButton('abort', a);
  	disableButton('retrieve', r);
}

function logGetDownload(laststat, rxpacket, cmd, len, seq) {
	if (! laststat) {
    setGroupButton(false, true, false);
		
		writeLogData();
		setProgress(100);
		return;
	}
	var i;
	
	if (fetchAborted)
		return;

	//console.log('cmd= ' + cmd + ' len= ' + len + ' seq= ' + seq);
	if (seq >= 0) {
		var rxBuf = new Uint8Array(rxpacket);
	}
	if (seq == 0) {
		// form string from first bytes, just to check if out-of-band message
		//
		var response = '';
		for (i = 0; i < len && i < 14; i++) {
			if (rxBuf[6 + i] == 0)
				break;
			response += String.fromCharCode(rxBuf[6 + i]);
		}
		if (response.search('nding logs') > 0) {
			logPacketCount = 0; // to stop read loop
			reportStatus('Finished Download');
			logGetDownload(false, rxpacket, 0, 0);
			return;
		}
		// this is the first packet
		//
		logPacketRead = 0;
		setProgress(((logPacketRead + 1) * 100) / logPacketCount);
	}
	else if (seq < 0) {
		if (logPacketCount > 0)
			RecvBulkPacketData(TARGET_DOWNLOADLOG, null, logGetDownload);
		return;
	}
	else {
		setProgress(logPacketRead * 100 / logPacketCount);
	}
	if (seq != logPacketRead) {
		console.log('Packet Sequence Error ' + 'seq=' + seq + ' logPacketRead=' + logPacketRead);
		abortFetch();
		return;
	}
	// copy bytes to our content buffer
	//
	logPacketRead++;
	for (i = 0; i < len && logIndex < logFileLen; i++)
		logBuf[logIndex++] = rxBuf[6 + i];
}

function logStartDownload(laststat, result) {
	if (! laststat) {
    setGroupButton(false, true, false);

		return;
	}
	console.log('DL ' + result);
	
	// expect "start download"
	//
	if (result.search('arting logs') > 0) {
		reportStatus('Starting Download');

		logPacketCount = 0;
		logPacketRead  = 0;
		logFileLen     = 0;

		// extract packet count and data size from string
		// of format "starting logs file-length packet-count"
		//
		var fls = result.slice(14);
		var fle = fls.search(' ');
		var pcs;
		if (fle > 0) {
			pcs = fls.slice(fle+1);
			fls = fls.slice(0, fle);
		}
		else {
			pcs = '0';
		}
		var pce = pcs.search(' ');
		if (pce > 0) {
			pcs = pcs.slice(0, pce);
		}
		logFileLen = Number(fls);
		logPacketCount = Number(pcs);
		var calcpackets = Math.round(logFileLen / 57);
		if (calcpackets > logPacketCount) {
			console.log('pcnt is wrong, need ' + calcpackets + ' not ' + logPacketCount);
		}
		console.log('PACKETS: ' + logPacketCount + ' fileLen: ' + logFileLen);
		if (logPacketCount > 0) {
			// alloc buffer for results
			logContent = new ArrayBuffer(logFileLen);
			logBuf = new Uint8Array(logContent);
			logIndex = 0;
			RecvBulkPacketData(TARGET_DOWNLOADLOG, null, logGetDownload);
		}
		else {
			reportStatus('Finished Download, no log data');
		}
	}
	else {
		abortFetch();
	}
}

function logAdvance(devtype) {
	switch (devtype.type) {
	case USBDEV_NONE:
	default:
		console.log('not connected');
		break;
	case USBDEV_REVO1:
		break;
	case USBDEV_REVO2:
		// begin download sequence
		DataPacket_RunCommand(TARGET_DOWNLOADLOG, 'Download Logs', 13, reportSerialStatus, logStartDownload);
		break;
	case USBDEV_CYP:
		// todo - reboot?
		console.log('not connected');
		break;
	}
}

function onFetch() {
	if (isconnected) {
	  setGroupButton(true, false, true);

		totalProgress = 0;
		progressOperations = 100;
		progOperation = 0;
		setProgress(10);

		checkDevice(logAdvance);
	}
	else {
		conDialog.showModal();
	}
}

function onAbort() {
	abortFetch();
}

function showDeviceState(connected) {
		span = document.getElementById('connstat');
		txt = document.createTextNode(connected.state);
		span.innerText = txt.textContent;
		
		disableButton('selpath', (connected.state != 'Connected'));
    disableButton('retrieve', true);
}

function updateConnStatus() {
	checkDevice(showDeviceState);
}

function onPlugDevice(device) {
	console.log('Plug device ' + device.vendorId + ':' + device.productId);
	updateConnStatus();
}

function onPullDevice(device) {
	console.log('Pulled device ' + device.vendorId + ':' + device.productId);
	updateConnStatus();
}

document.addEventListener('DOMContentLoaded', function () {
	//console.log('loaded log page');
	conDialog = document.getElementById('connectMeNowDialog');
	document.querySelector('#connectMeNowClose').onclick = function() {
		conDialog.close();
	};
	setProgress(0);
	
	document.getElementById('selpath').addEventListener('click', onSelPath);
	document.getElementById('retrieve').addEventListener('click', onFetch);
	document.getElementById('abort').addEventListener('click', onAbort);

	chrome.usb.onDeviceAdded.addListener(onPlugDevice)
	chrome.usb.onDeviceRemoved.addListener(onPullDevice)

  setGroupButton(true, true, false);

	var ta = document.getElementById('status');
	ta.value = '';
	reportStatus('Note: Retrieving Logs during an active call will interrupt the audio');

	isconnected = -1;
	updateConnStatus();
	/* not needed, listenting for events
	setInterval(updateConnStatus, 1000);
	*/
});

