
var connectionCount = 0;

function hidCloseDevice(connId) {
	chrome.hid.disconnect(connId, function(res) { });
}

function hidWriteData(connId, txdata, reportId, replyCallback) {
	var laststat = true;

	//console.log('send ' + txdata.byteLength + ' bytes on con ' + connId);
	chrome.hid.send(connId, +0, txdata, function() {
		if (chrome.runtime.lastError) {
			console.log('hid send failed:' + chrome.runtime.lastError.message);
			laststat= false;
		}
		replyCallback(connId, laststat, reportId);
	});
}
	
function hidReadData(connId, replyCallback) {
	chrome.hid.receive(connId, function(reportId, rxdata) {
		var laststat = true;
		if (chrome.runtime.lastError) {
			console.log('hid read failed:' + chrome.runtime.lastError.message);
			laststat = false;
		}
		//console.log('hid rx' + rxdata.byteLength);
		replyCallback(connId, laststat, rxdata);
	});
}
	
function hidReportStatus(statstr) {
	var ta = document.getElementById('status');
	ta.value += (statstr + '\n');
    ta.scrollTop = ta.scrollHeight;
}

function hidGetDeviceId() {
  var deviceIds = [];
	var permissions = chrome.runtime.getManifest().permissions;
	var i = 0;
	
	// list usb devices we've ask permission for
	//
	for (i = 0; i < permissions.length; ++i) {
		var p = permissions[i];

		if (p.hasOwnProperty('usbDevices')) {
			deviceIds = deviceIds.concat(p.usbDevices);
		} else if (p.hasOwnProperty('hidDevices')) {
      deviceIds = deviceIds.concat(p.hidDevices);
      console.log('Device id: ' + deviceIds[i]);
		}
		
	}
	
	return deviceIds;
}

function hidFindDevice (vid, pid, deviceIds) {
	var foundOne = false;
	var devId = -1;

 	for (n = 0; n < deviceIds.length && ! foundOne; n++) {
		chrome.hid.getDevices(deviceIds[n], function(devices) {
		//chrome.hid.getDevices({}, function(devices) {
			for(i = 0; i < devices.length && ! foundOne; i++) {
				if (devices[i].vendorId == vid && devices[i].productId == pid) {
					console.log('use hid device ' + i + ' ' + devices[i].vendorId.toString(16) + ':' +
						devices[i].productId.toString(16));
					//hidReportStatus('use hid device ' + i + ' ' + devices[i].vendorId.toString(16) + ':' +
						//devices[i].productId.toString(16));
							
					foundOne = true;
					devId = devices[i];
					
					chrome.hid.connect(devId, function(connectInfo) {
      			if (! connectInfo) {
  		    		console.warn('Unable to connect to hid device.');
    
  		    	} else {
  		    	  hidConnection.connId = connectInfo.connectionId;
  				    console.log('Run hid connected');
  			    }
					});
					
					break;
				} else {
					console.log('gotvp = ' + devices[i].productId + ':' + devices[i].vendorId + '  want ' +
							vid + ':' + pid);
				}
			}
			if (! foundOne && (devices.length > 0)) {
				// getting here means device not in list
				console.warn("Unable to find to hid device.");
				hidReportStatus("Unable to find to hid device.");
			}
		});
 	}

 	return devId;
}

function hidUseDevice(vid, pid, andDo, opcode) {
	//var deviceIds = [];
  var n, i;
	var deviceIds = hidGetDeviceId();
	var foundOne = false;

	for (n = 0; n < deviceIds.length && ! foundOne; n++) {
		chrome.hid.getDevices(deviceIds[n], function(devices) {
		//chrome.hid.getDevices({}, function(devices) {
			for(i = 0; i < devices.length && ! foundOne; i++) {
				if (devices[i].vendorId == vid && devices[i].productId == pid) {
					console.log('use hid device ' + i + ' ' + devices[i].vendorId.toString(16) + ':' +
						devices[i].productId.toString(16));
					hidReportStatus('use hid device ' + i + ' ' + devices[i].vendorId.toString(16) + ':' +
						devices[i].productId.toString(16));
							
					chrome.hid.connect(devices[i].deviceId, function(connectInfo) {
						if (! connectInfo) {
							console.warn('Unable to connect to hid device.');
              hidReportStatus('Unable to connect to hid device, vid: ' + vid + ' pid ' + pid);

							andDo(-1, opcode);
						} else {
							//console.log('Run hid connected');
							andDo(connectInfo.connectionId, opcode);
						}
					});
					foundOne = true;
				} else {
					console.log('gotvp = ' + devices[i].productId + ':' + devices[i].vendorId + '  want ' +
							vid + ':' + pid);
				}
			}
			if (! foundOne && (devices.length > 0)) {
				// getting here means device not in list
				console.warn("Unable to find to hid device.");
				hidReportStatus("Unable to find to hid device.");
				andDo(-1, opcode);
			}
		});
	}
}

function hidSetModeWithDevice(connId, mode) {
	var bytes = new ArrayBuffer(1);
	var bb = new Uint8Array(bytes);

	console.log('setmode ' + mode);
	
	switch (mode)
	{
	case USB_MODE_NORMAL:
	case USB_MODE_PC:
	case USB_MODE_RESET:
	    bb[0] = mode;
		break;
	default:
		console.log('bad mode');
		return;
	}
	chrome.hid.send(connId, 4, bytes, function() {
		if (chrome.runtime.lastError) {
			console.log('hid send failed');
		}
		// setting the mode can cause reenum which invalidates 
		// this connection, so we expect this to fail in spme cases
		//
		hidCloseDevice(connId);
 	});
}

function hidSetMode(mode) {
	// mode setting only valid in revo-mode, not cymode
	hidUseDevice(USB_VENDOR_ID, USB_PRODUCT_ID1, hidSetModeWithDevice, mode);
}

